// getControllertypeConfiguration

if (raisedEvent.parameter.actions == 'sync') {
	if (Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken') == null) {
		lWarn.logln('cloud not active, just waiting a little longer');
		new Event('heating-controller.cloud',{actions:'sync',time:'+60'}).raise();
	} else {
		var handle = new WebserviceConnection();
		handle.simplerequest('public/dss/v1_1/DSSHeating/GetControllerPIDConfigurationTemplate', '', 'GET', true, function(code, data) {
			if (code === 200) {
				lInfo.logln(': OK [' + code + ']');
			} else {
				lInfo.logln(': FAILED! Server replied: "' + code + '"');
			}
			lInfo.logln(data);
			var oValue = (JSON.parse(data)).Response.ControllerTypeConfigurationList;
			Property.getNode('/scripts/heating-controller').removeChild('controllerDefinitions');
			for ( var iIndex = 0; iIndex < oValue.length; iIndex++) {
				var oVal = oValue[iIndex];
				var id = oVal.HeatingControllerTypeId;
				Property.setProperty('controllerDefinitions/' + id + '/id', id);
				Property.setProperty('controllerDefinitions/' + id + '/controllerMode', 1);
				Property.setProperty('controllerDefinitions/' + id + '/name', oVal.DisplayName);
				Property.setProperty('controllerDefinitions/' + id + '/kp', "" + oVal.CtrlKp);
				Property.setProperty('controllerDefinitions/' + id + '/ts', Math.floor(oVal.CtrlTs));
				Property.setProperty('controllerDefinitions/' + id + '/kd', Math.floor(oVal.CtrlKp));
				Property.setProperty('controllerDefinitions/' + id + '/ti', Math.floor(oVal.CtrlTi));
				Property.setProperty('controllerDefinitions/' + id + '/imin', "" + oVal.CtrlImin);
				Property.setProperty('controllerDefinitions/' + id + '/imax', "" + oVal.CtrlImax);
				Property.setProperty('controllerDefinitions/' + id + '/ymin', Math.floor(oVal.CtrlYmin + 0.5));
				Property.setProperty('controllerDefinitions/' + id + '/ymax', Math.floor(oVal.CtrlYmax + 0.5));
				Property.setProperty('controllerDefinitions/' + id + '/antiwindup', oVal.CtrlAntiWindup ? 1 : 0);
				Property.setProperty('controllerDefinitions/' + id + '/keepfloorwarm', oVal.CtrlKeepFloorWarm ? 1 : 0);
			}
		});
	}
}